]> git.ipfire.org Git - people/pmueller/ipfire-2.x.git/blob - make.sh
buildprocess: Add extra metadata to pak lfs files
[people/pmueller/ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2007-2022 IPFire Team <info@ipfire.org>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 # If you update the version don't forget to update backupiso and add it to core update
28 VERSION="2.27" # Version number
29 CORE="165" # Core Level (Filename)
30 SLOGAN="www.ipfire.org" # Software slogan
31 CONFIG_ROOT=/var/ipfire # Configuration rootdir
32 MAX_RETRIES=1 # prefetch/check loop
33 BUILD_IMAGES=1 # Flash and Xen Downloader
34 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
35
36 # Information from Git
37 GIT_BRANCH="$(git rev-parse --abbrev-ref HEAD)" # Git Branch
38 GIT_TAG="$(git tag | tail -1)" # Git Tag
39 GIT_LASTCOMMIT="$(git rev-parse --verify HEAD)" # Last commit
40
41 TOOLCHAINVER=20220203
42
43 # use multicore and max compression
44 ZSTD_OPT="-T0 --ultra -22"
45
46 ###############################################################################
47 #
48 # Beautifying variables & presentation & input output interface
49 #
50 ###############################################################################
51
52 # Remember if the shell is interactive or not
53 if [ -t 0 ] && [ -t 1 ]; then
54 INTERACTIVE=true
55 else
56 INTERACTIVE=false
57 fi
58
59 # Sets or adjusts pretty formatting variables
60 resize_terminal() {
61 ## Screen Dimentions
62 # Find current screen size
63 COLUMNS=$(tput cols)
64
65 # When using remote connections, such as a serial port, stty size returns 0
66 if ! ${INTERACTIVE} || [ "${COLUMNS}" = "0" ]; then
67 COLUMNS=80
68 fi
69
70 # Measurements for positioning result messages
71 OPTIONS_WIDTH=20
72 TIME_WIDTH=12
73 STATUS_WIDTH=8
74 NAME_WIDTH=$(( COLUMNS - OPTIONS_WIDTH - TIME_WIDTH - STATUS_WIDTH ))
75 LINE_WIDTH=$(( COLUMNS - STATUS_WIDTH ))
76
77 TIME_COL=$(( NAME_WIDTH + OPTIONS_WIDTH ))
78 STATUS_COL=$(( TIME_COL + TIME_WIDTH ))
79 }
80
81 # Initially setup terminal
82 resize_terminal
83
84 # Call resize_terminal when terminal is being resized
85 trap "resize_terminal" WINCH
86
87 # Define color for messages
88 BOLD="\\033[1;39m"
89 DONE="\\033[1;32m"
90 SKIP="\\033[1;34m"
91 WARN="\\033[1;35m"
92 FAIL="\\033[1;31m"
93 NORMAL="\\033[0;39m"
94
95 # New architecture variables
96 HOST_ARCH="$(uname -m)"
97
98 PWD=$(pwd)
99 BASENAME=$(basename $0)
100
101 # Debian specific settings
102 if [ ! -e /etc/debian_version ]; then
103 FULLPATH=`which $0`
104 else
105 if [ -x /usr/bin/realpath ]; then
106 FULLPATH=`/usr/bin/realpath $0`
107 else
108 echo "ERROR: Need to do apt-get install realpath"
109 exit 1
110 fi
111 fi
112
113 # This is the directory where make.sh is in
114 export BASEDIR=$(echo $FULLPATH | sed "s/\/$BASENAME//g")
115
116 LOGFILE=$BASEDIR/log/_build.preparation.log
117 export LOGFILE
118 DIR_CHK=$BASEDIR/cache/check
119 mkdir $BASEDIR/log/ 2>/dev/null
120
121 system_processors() {
122 getconf _NPROCESSORS_ONLN 2>/dev/null || echo "1"
123 }
124
125 system_memory() {
126 local key val unit
127
128 while read -r key val unit; do
129 case "${key}" in
130 MemTotal:*)
131 # Convert to MB
132 echo "$(( ${val} / 1024 ))"
133 break
134 ;;
135 esac
136 done < /proc/meminfo
137 }
138
139 configure_build() {
140 local build_arch="${1}"
141
142 if [ "${build_arch}" = "default" ]; then
143 build_arch="$(configure_build_guess)"
144 fi
145
146 case "${build_arch}" in
147 x86_64)
148 BUILDTARGET="${build_arch}-pc-linux-gnu"
149 CROSSTARGET="${build_arch}-cross-linux-gnu"
150 BUILD_PLATFORM="x86"
151 CFLAGS_ARCH="-m64 -mtune=generic -fstack-clash-protection -fcf-protection"
152 ;;
153
154 aarch64)
155 BUILDTARGET="${build_arch}-pc-linux-gnu"
156 CROSSTARGET="${build_arch}-cross-linux-gnu"
157 BUILD_PLATFORM="arm"
158 CFLAGS_ARCH="-fstack-clash-protection"
159 ;;
160
161 armv7hl)
162 BUILDTARGET="${build_arch}-pc-linux-gnueabi"
163 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
164 BUILD_PLATFORM="arm"
165 CFLAGS_ARCH="-march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=hard"
166 ;;
167
168 armv6l)
169 BUILDTARGET="${build_arch}-pc-linux-gnueabi"
170 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
171 BUILD_PLATFORM="arm"
172 CFLAGS_ARCH="-march=armv6zk+fp -mfpu=vfp -mfloat-abi=softfp -fomit-frame-pointer"
173 ;;
174
175 riscv64)
176 BUILDTARGET="${build_arch}-pc-linux-gnu"
177 CROSSTARGET="${build_arch}-cross-linux-gnu"
178 BUILD_PLATFORM="riscv"
179 CFLAGS_ARCH="-fstack-clash-protection"
180 ;;
181
182 *)
183 exiterror "Cannot build for architure ${build_arch}"
184 ;;
185 esac
186
187 # Check if the QEMU helper is available if needed.
188 if qemu_is_required "${build_arch}"; then
189 local qemu_build_helper="$(qemu_find_build_helper_name "${build_arch}")"
190
191 if [ -n "${qemu_build_helper}" ]; then
192 QEMU_TARGET_HELPER="${qemu_build_helper}"
193 else
194 exiterror "Could not find a binfmt_misc helper entry for ${build_arch}"
195 fi
196 fi
197
198 BUILD_ARCH="${build_arch}"
199 TOOLS_DIR="/tools_${BUILD_ARCH}"
200
201 # Enables hardening
202 HARDENING_CFLAGS="-Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong"
203
204 CFLAGS="-O2 -pipe -Wall -fexceptions -fPIC ${CFLAGS_ARCH}"
205 CXXFLAGS="${CFLAGS}"
206
207 RUSTFLAGS="-Copt-level=3 -Clink-arg=-Wl,-z,relro,-z,now -Ccodegen-units=1 --cap-lints=warn ${RUSTFLAGS_ARCH}"
208
209 # Determine parallelism
210 # We assume that each process consumes about
211 # 128MB of memory. Therefore we find out how
212 # many processes fit into memory.
213 local mem_max=$(( ${SYSTEM_MEMORY} / 128 ))
214 local cpu_max=$(( ${SYSTEM_PROCESSORS} ))
215
216 local parallelism
217 if [ ${mem_max} -lt ${cpu_max} ]; then
218 parallelism=${mem_max}
219 else
220 parallelism=${cpu_max}
221 fi
222
223 # Use this as default PARALLELISM
224 DEFAULT_PARALLELISM="${parallelism}"
225
226 # Limit lauched ninja build jobs to computed parallel value.
227 NINJAJOBS="${parallelism}"
228
229 # Compression parameters
230 # We use mode 8 for reasonable memory usage when decompressing
231 # but with overall good compression
232 XZ_OPT="-8"
233
234 # We try to use as many cores as possible
235 XZ_OPT="${XZ_OPT} -T0"
236
237 # We need to limit memory because XZ uses too much when running
238 # in parallel and it isn't very smart in limiting itself.
239 # We allow XZ to use up to 70% of all system memory.
240 local xz_memory=$(( SYSTEM_MEMORY * 7 / 10 ))
241
242 # XZ memory cannot be larger than 2GB on 32 bit systems
243 case "${build_arch}" in
244 armv*)
245 if [ ${xz_memory} -gt 2048 ]; then
246 xz_memory=2048
247 fi
248 ;;
249 esac
250
251 XZ_OPT="${XZ_OPT} --memory=${xz_memory}MiB"
252 }
253
254 configure_build_guess() {
255 case "${HOST_ARCH}" in
256 x86_64)
257 echo "x86_64"
258 ;;
259
260 aarch64)
261 echo "aarch64"
262 ;;
263
264 armv7*|armv6*)
265 echo "armv6l"
266 ;;
267
268 riscv64)
269 echo "riscv64"
270 ;;
271
272 *)
273 exiterror "Cannot guess build architecture"
274 ;;
275 esac
276 }
277
278 stdumount() {
279 umount $BASEDIR/build/sys 2>/dev/null;
280 umount $BASEDIR/build/dev/shm 2>/dev/null;
281 umount $BASEDIR/build/dev/pts 2>/dev/null;
282 umount $BASEDIR/build/dev 2>/dev/null;
283 umount $BASEDIR/build/proc 2>/dev/null;
284 umount $BASEDIR/build/install/mnt 2>/dev/null;
285 umount $BASEDIR/build/usr/src/cache 2>/dev/null;
286 umount $BASEDIR/build/usr/src/ccache 2>/dev/null;
287 umount $BASEDIR/build/usr/src/config 2>/dev/null;
288 umount $BASEDIR/build/usr/src/doc 2>/dev/null;
289 umount $BASEDIR/build/usr/src/html 2>/dev/null;
290 umount $BASEDIR/build/usr/src/langs 2>/dev/null;
291 umount $BASEDIR/build/usr/src/lfs 2>/dev/null;
292 umount $BASEDIR/build/usr/src/log 2>/dev/null;
293 umount $BASEDIR/build/usr/src/src 2>/dev/null;
294 umount $BASEDIR/build/usr/src 2>/dev/null;
295 umount $BASEDIR/build/tmp 2>/dev/null;
296 }
297
298 now() {
299 date -u "+%s"
300 }
301
302 format_runtime() {
303 local seconds=${1}
304
305 if [ ${seconds} -ge 3600 ]; then
306 printf "%d:%02d:%02d\n" \
307 "$(( seconds / 3600 ))" \
308 "$(( seconds % 3600 / 60 ))" \
309 "$(( seconds % 3600 % 60 ))"
310 elif [ ${seconds} -ge 60 ]; then
311 printf "%d:%02d\n" \
312 "$(( seconds / 60 ))" \
313 "$(( seconds % 60 ))"
314 else
315 printf "%d\n" "${seconds}"
316 fi
317 }
318
319 print_line() {
320 local line="$@"
321
322 printf "%-${LINE_WIDTH}s" "${line}"
323 }
324
325 _print_line() {
326 local status="${1}"
327 shift
328
329 if ${INTERACTIVE}; then
330 printf "${!status}"
331 fi
332
333 print_line "$@"
334
335 if ${INTERACTIVE}; then
336 printf "${NORMAL}"
337 fi
338 }
339
340 print_headline() {
341 _print_line BOLD "$@"
342 }
343
344 print_error() {
345 _print_line FAIL "$@"
346 }
347
348 print_package() {
349 local name="${1}"
350 shift
351
352 local version="$(grep -E "^VER |^VER=|^VER " $BASEDIR/lfs/${name} | awk '{ print $3 }')"
353 local options="$@"
354
355 local string="${name}"
356 if [ -n "${version}" ] && [ "${version}" != "ipfire" ]; then
357 string="${string} (${version})"
358 fi
359
360 printf "%-$(( ${NAME_WIDTH} - 1 ))s " "${string}"
361 printf "%$(( ${OPTIONS_WIDTH} - 1 ))s " "${options}"
362 }
363
364 print_runtime() {
365 local runtime=$(format_runtime $@)
366
367 if ${INTERACTIVE}; then
368 printf "\\033[${TIME_COL}G[ ${BOLD}%$(( ${TIME_WIDTH} - 4 ))s${NORMAL} ]" "${runtime}"
369 else
370 printf "[ %$(( ${TIME_WIDTH} - 4 ))s ]" "${runtime}"
371 fi
372 }
373
374 print_status() {
375 local status="${1}"
376
377 local color="${!status}"
378
379 if ${INTERACTIVE}; then
380 printf "\\033[${STATUS_COL}G[${color-${BOLD}} %-$(( ${STATUS_WIDTH} - 4 ))s ${NORMAL}]\n" "${status}"
381 else
382 printf "[ %-$(( ${STATUS_WIDTH} - 4 ))s ]\n" "${status}"
383 fi
384 }
385
386 print_build_stage() {
387 print_headline "$@"
388
389 # end line
390 printf "\n"
391 }
392
393 print_build_summary() {
394 local runtime=$(format_runtime $@)
395
396 print_line "*** Build finished in ${runtime}"
397 print_status DONE
398 }
399
400 exiterror() {
401 stdumount
402 for i in `seq 0 7`; do
403 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
404 losetup -d /dev/loop${i} 2>/dev/null
405 fi;
406 done
407
408 # Dump logfile
409 if [ -n "${LOGFILE}" ] && [ -e "${LOGFILE}" ]; then
410 echo # empty line
411
412 local line
413 while read -r line; do
414 echo " ${line}"
415 done <<< "$(tail -n30 ${LOGFILE})"
416 fi
417
418 echo # empty line
419
420 local line
421 for line in "ERROR: $@" " Check ${LOGFILE} for errors if applicable"; do
422 print_error "${line}"
423 print_status FAIL
424 done
425
426 exit 1
427 }
428
429 prepareenv() {
430 # Are we running the right shell?
431 if [ -z "${BASH}" ]; then
432 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
433 fi
434
435 if [ -z "${BASH_VERSION}" ]; then
436 exiterror "Not running BASH shell."
437 fi
438
439 # Trap on emergency exit
440 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
441
442 # Checking if running as root user
443 if [ $(id -u) -ne 0 ]; then
444 exiterror "root privileges required for building"
445 fi
446
447 # Checking for necessary temporary space
448 print_line "Checking for necessary space on disk $BASE_DEV"
449 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
450 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
451 if (( 2048000 > $BASE_ASPACE )); then
452 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
453 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
454 print_status FAIL
455 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
456 fi
457 else
458 print_status DONE
459 fi
460
461 # Set umask
462 umask 022
463
464 # Set LFS Directory
465 LFS=$BASEDIR/build
466
467 # Setup environment
468 set +h
469 LC_ALL=POSIX
470 export LFS LC_ALL CFLAGS CXXFLAGS DEFAULT_PARALLELISM RUSTFLAGS NINJAJOBS
471 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
472
473 # Make some extra directories
474 mkdir -p "${BASEDIR}/build${TOOLS_DIR}" 2>/dev/null
475 mkdir -p $BASEDIR/build/{etc,usr/src} 2>/dev/null
476 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
477 mkdir -p $BASEDIR/{cache,ccache/${BUILD_ARCH}/${TOOLCHAINVER}} 2>/dev/null
478
479 if [ "${ENABLE_RAMDISK}" = "on" ]; then
480 mkdir -p $BASEDIR/build/usr/src
481 mount -t tmpfs tmpfs -o size=8G,nr_inodes=1M,mode=1777 $BASEDIR/build/usr/src
482
483 mkdir -p ${BASEDIR}/build/tmp
484 mount -t tmpfs tmpfs -o size=4G,nr_inodes=1M,mode=1777 ${BASEDIR}/build/tmp
485 fi
486
487 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
488
489 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
490 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
491
492 # Make all sources and proc available under lfs build
493 mount --bind /dev $BASEDIR/build/dev
494 mount --bind /dev/pts $BASEDIR/build/dev/pts
495 mount --bind /dev/shm $BASEDIR/build/dev/shm
496 mount --bind /proc $BASEDIR/build/proc
497 mount --bind /sys $BASEDIR/build/sys
498 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
499 mount --bind $BASEDIR/ccache/${BUILD_ARCH}/${TOOLCHAINVER} $BASEDIR/build/usr/src/ccache
500 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
501 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
502 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
503 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
504 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
505 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
506 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
507
508 # Run LFS static binary creation scripts one by one
509 export CCACHE_DIR=$BASEDIR/ccache
510 export CCACHE_TEMPDIR="/tmp"
511 export CCACHE_COMPILERCHECK="string:toolchain-${TOOLCHAINVER} ${BUILD_ARCH}"
512
513 # Remove pre-install list of installed files in case user erase some files before rebuild
514 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
515
516 # Prepare string for /etc/system-release.
517 local system_release="${NAME} ${VERSION} (${BUILD_ARCH})"
518
519 case "${GIT_BRANCH}" in
520 core*|beta?|rc?)
521 system_release="${system_release} - ${GIT_BRANCH}"
522 ;;
523 *)
524 system_release="${system_release} - core${CORE} Development Build: ${GIT_BRANCH}/${GIT_LASTCOMMIT:0:8}"
525 ;;
526 esac
527
528 # Append -dirty tag for local changes
529 if [ "$(git status -s | wc -l)" != "0" ]; then
530 system_release="${system_release}-dirty"
531 fi
532
533 # Export variable
534 SYSTEM_RELEASE="${system_release}"
535
536 # Decide on PAKFIRE_TREE
537 case "${GIT_BRANCH}" in
538 core*)
539 PAKFIRE_TREE="stable"
540 ;;
541 master)
542 PAKFIRE_TREE="testing"
543 ;;
544 *)
545 PAKFIRE_TREE="unstable"
546 ;;
547 esac
548
549 # Setup ccache cache size
550 enterchroot ccache --max-size="${CCACHE_CACHE_SIZE}" >/dev/null
551 }
552
553 enterchroot() {
554 # Install QEMU helper, if needed
555 qemu_install_helper
556
557 local PATH="${TOOLS_DIR}/ccache/bin:/bin:/usr/bin:/sbin:/usr/sbin:${TOOLS_DIR}/sbin:${TOOLS_DIR}/bin"
558
559 # Prepend any custom changes to PATH
560 if [ -n "${CUSTOM_PATH}" ]; then
561 PATH="${CUSTOM_PATH}:${PATH}"
562 fi
563
564 PATH="${PATH}" chroot ${LFS} env -i \
565 HOME="/root" \
566 TERM="${TERM}" \
567 PS1="${PS1}" \
568 PATH="${PATH}" \
569 SYSTEM_RELEASE="${SYSTEM_RELEASE}" \
570 PAKFIRE_TREE="${PAKFIRE_TREE}" \
571 NAME="${NAME}" \
572 SNAME="${SNAME}" \
573 VERSION="${VERSION}" \
574 CORE="${CORE}" \
575 SLOGAN="${SLOGAN}" \
576 TOOLS_DIR="${TOOLS_DIR}" \
577 CONFIG_ROOT="${CONFIG_ROOT}" \
578 CFLAGS="${CFLAGS} ${HARDENING_CFLAGS}" \
579 CXXFLAGS="${CXXFLAGS} ${HARDENING_CFLAGS}" \
580 RUSTFLAGS="${RUSTFLAGS}" \
581 BUILDTARGET="${BUILDTARGET}" \
582 CROSSTARGET="${CROSSTARGET}" \
583 BUILD_ARCH="${BUILD_ARCH}" \
584 BUILD_PLATFORM="${BUILD_PLATFORM}" \
585 CCACHE_DIR=/usr/src/ccache \
586 CCACHE_TEMPDIR="${CCACHE_TEMPDIR}" \
587 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
588 GOCACHE="/usr/src/ccache/go" \
589 KVER="${KVER}" \
590 XZ_OPT="${XZ_OPT}" \
591 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
592 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
593 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
594 $(fake_environ) \
595 $(qemu_environ) \
596 "$@"
597 }
598
599 entershell() {
600 if [ ! -e $BASEDIR/build/usr/src/lfs/ ]; then
601 exiterror "No such file or directory: $BASEDIR/build/usr/src/lfs/"
602 fi
603
604 echo "Entering to a shell inside LFS chroot, go out with exit"
605 local PS1="ipfire build chroot (${BUILD_ARCH}) \u:\w\$ "
606
607 if enterchroot bash -i; then
608 stdumount
609 else
610 print_status FAIL
611 exiterror "chroot error"
612 fi
613 }
614
615 lfsmakecommoncheck() {
616 # Script present?
617 if [ ! -f $BASEDIR/lfs/$1 ]; then
618 exiterror "No such file or directory: $BASEDIR/$1"
619 fi
620
621 # Print package name and version
622 print_package $@
623
624 # Check if this package is supported by our architecture.
625 # If no SUP_ARCH is found, we assume the package can be built for all.
626 if grep "^SUP_ARCH" ${BASEDIR}/lfs/${1} >/dev/null; then
627 # Check if package supports ${BUILD_ARCH} or all architectures.
628 if ! grep -E "^SUP_ARCH.*${BUILD_ARCH}|^SUP_ARCH.*all" ${BASEDIR}/lfs/${1} >/dev/null; then
629 print_runtime 0
630 print_status SKIP
631 return 1
632 fi
633 fi
634
635 # Script slipped?
636 local i
637 for i in $SKIP_PACKAGE_LIST
638 do
639 if [ "$i" == "$1" ]; then
640 print_status SKIP
641 return 1;
642 fi
643 done
644
645 echo -ne "`date -u '+%b %e %T'`: Building $* " >> $LOGFILE
646
647 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
648 MESSAGE="$1\t " download >> $LOGFILE 2>&1
649 if [ $? -ne 0 ]; then
650 exiterror "Download error in $1"
651 fi
652
653 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
654 MESSAGE="$1\t md5sum" md5 >> $LOGFILE 2>&1
655 if [ $? -ne 0 ]; then
656 exiterror "md5sum error in $1, check file in cache or signature"
657 fi
658
659 return 0 # pass all!
660 }
661
662 lfsmake1() {
663 lfsmakecommoncheck $*
664 [ $? == 1 ] && return 0
665
666 # Set PATH to use the toolchain tools first and then whatever the host has set
667 local PATH="${TOOLS_DIR}/ccache/bin:${TOOLS_DIR}/sbin:${TOOLS_DIR}/bin:${PATH}"
668
669 if [ -n "${CUSTOM_PATH}" ]; then
670 PATH="${CUSTOM_PATH}:${PATH}"
671 fi
672
673 cd $BASEDIR/lfs && env -i \
674 PATH="${PATH}" \
675 CCACHE_DIR="${CCACHE_DIR}"/${BUILD_ARCH}/${TOOLCHAINVER} \
676 CCACHE_TEMPDIR="${CCACHE_TEMPDIR}" \
677 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
678 CFLAGS="${CFLAGS}" \
679 CXXFLAGS="${CXXFLAGS}" \
680 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
681 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
682 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
683 make -f $* \
684 TOOLCHAIN=1 \
685 TOOLS_DIR="${TOOLS_DIR}" \
686 CROSSTARGET="${CROSSTARGET}" \
687 BUILDTARGET="${BUILDTARGET}" \
688 BUILD_ARCH="${BUILD_ARCH}" \
689 BUILD_PLATFORM="${BUILD_PLATFORM}" \
690 LFS_BASEDIR="${BASEDIR}" \
691 ROOT="${LFS}" \
692 KVER="${KVER}" \
693 install >> $LOGFILE 2>&1 &
694
695 if ! wait_until_finished $!; then
696 print_status FAIL
697 exiterror "Building $*"
698 fi
699
700 print_status DONE
701 }
702
703 lfsmake2() {
704 lfsmakecommoncheck $*
705 [ $? == 1 ] && return 0
706
707 local PS1='\u:\w$ '
708
709 enterchroot \
710 bash -x -c "cd /usr/src/lfs && \
711 make -f $* \
712 LFS_BASEDIR=/usr/src install" \
713 >> ${LOGFILE} 2>&1 &
714
715 if ! wait_until_finished $!; then
716 print_status FAIL
717 exiterror "Building $*"
718 fi
719
720 print_status DONE
721 }
722
723 ipfiredist() {
724 lfsmakecommoncheck $*
725 [ $? == 1 ] && return 0
726
727 local PS1='\u:\w$ '
728
729 enterchroot \
730 bash -x -c "cd /usr/src/lfs && make -f $* LFS_BASEDIR=/usr/src dist" \
731 >> ${LOGFILE} 2>&1 &
732
733 if ! wait_until_finished $!; then
734 print_status FAIL
735 exiterror "Packaging $*"
736 fi
737
738 print_status DONE
739 }
740
741 wait_until_finished() {
742 local pid=${1}
743
744 local start_time=$(now)
745
746 # Show progress
747 if ${INTERACTIVE}; then
748 # Wait a little just in case the process
749 # has finished very quickly.
750 sleep 0.1
751
752 local runtime
753 while kill -0 ${pid} 2>/dev/null; do
754 print_runtime $(( $(now) - ${start_time} ))
755
756 # Wait a little
757 sleep 1
758 done
759 fi
760
761 # Returns the exit code of the child process
762 wait ${pid}
763 local ret=$?
764
765 if ! ${INTERACTIVE}; then
766 print_runtime $(( $(now) - ${start_time} ))
767 fi
768
769 return ${ret}
770 }
771
772 fake_environ() {
773 [ -e "${BASEDIR}/build${TOOLS_DIR}/lib/libpakfire_preload.so" ] || return
774
775 local env="LD_PRELOAD=${TOOLS_DIR}/lib/libpakfire_preload.so"
776
777 # Fake kernel version, because some of the packages do not compile
778 # with kernel 3.0 and later.
779 env="${env} UTS_RELEASE=${KVER}-ipfire"
780
781 # Fake machine version.
782 env="${env} UTS_MACHINE=${BUILD_ARCH}"
783
784 echo "${env}"
785 }
786
787 qemu_environ() {
788 local env
789
790 # Don't add anything if qemu is not used.
791 if ! qemu_is_required; then
792 return
793 fi
794
795 # Set default qemu options
796 case "${BUILD_ARCH}" in
797 arm*)
798 QEMU_CPU="${QEMU_CPU:-cortex-a9}"
799
800 env="${env} QEMU_CPU=${QEMU_CPU}"
801 ;;
802 esac
803
804 # Enable QEMU strace
805 #env="${env} QEMU_STRACE=1"
806
807 echo "${env}"
808 }
809
810 qemu_is_required() {
811 local build_arch="${1}"
812
813 if [ -z "${build_arch}" ]; then
814 build_arch="${BUILD_ARCH}"
815 fi
816
817 case "${HOST_ARCH},${build_arch}" in
818 x86_64,arm*|x86_64,aarch64|x86_64,riscv64|i?86,arm*|i?86,aarch64|i?86,x86_64)
819 return 0
820 ;;
821 *)
822 return 1
823 ;;
824 esac
825 }
826
827 qemu_install_helper() {
828 # Do nothing, if qemu is not required
829 if ! qemu_is_required; then
830 return 0
831 fi
832
833 if [ ! -e /proc/sys/fs/binfmt_misc/status ]; then
834 exiterror "binfmt_misc not mounted. QEMU_TARGET_HELPER not useable."
835 fi
836
837 if [ ! $(cat /proc/sys/fs/binfmt_misc/status) = 'enabled' ]; then
838 exiterror "binfmt_misc not enabled. QEMU_TARGET_HELPER not useable."
839 fi
840
841
842 if [ -z "${QEMU_TARGET_HELPER}" ]; then
843 exiterror "QEMU_TARGET_HELPER not set"
844 fi
845
846 # Check if the helper is already installed.
847 if [ -x "${LFS}${QEMU_TARGET_HELPER}" ]; then
848 return 0
849 fi
850
851 # Try to find a suitable binary that we can install
852 # to the build environment.
853 local file
854 for file in "${QEMU_TARGET_HELPER}" "${QEMU_TARGET_HELPER}-static"; do
855 # file must exist and be executable.
856 [ -x "${file}" ] || continue
857
858 # Must be static.
859 file_is_static "${file}" || continue
860
861 local dirname="${LFS}$(dirname "${file}")"
862 mkdir -p "${dirname}"
863
864 install -m 755 "${file}" "${LFS}${QEMU_TARGET_HELPER}"
865 return 0
866 done
867
868 exiterror "Could not find a statically-linked QEMU emulator: ${QEMU_TARGET_HELPER}"
869 }
870
871 qemu_find_build_helper_name() {
872 local build_arch="${1}"
873
874 local magic
875 case "${build_arch}" in
876 aarch64)
877 magic="7f454c460201010000000000000000000200b700"
878 ;;
879 arm*)
880 magic="7f454c4601010100000000000000000002002800"
881 ;;
882 riscv64)
883 magic="7f454c460201010000000000000000000200f300"
884 ;;
885 x86_64)
886 magic="7f454c4602010100000000000000000002003e00"
887 ;;
888 esac
889
890 [ -z "${magic}" ] && return 1
891
892 local file
893 for file in /proc/sys/fs/binfmt_misc/*; do
894 # skip write only register entry
895 [ $(basename "${file}") = "register" ] && continue
896 # Search for the file with the correct magic value.
897 grep -qE "^magic ${magic}$" "${file}" || continue
898
899 local interpreter="$(grep "^interpreter" "${file}" | awk '{ print $2 }')"
900
901 [ -n "${interpreter}" ] || continue
902 [ "${interpreter:0:1}" = "/" ] || continue
903 [ -x "${interpreter}" ] || continue
904
905 echo "${interpreter}"
906 return 0
907 done
908
909 return 1
910 }
911
912 file_is_static() {
913 local file="${1}"
914
915 file ${file} 2>/dev/null | grep -q "statically linked"
916 }
917
918 update_language_list() {
919 local path="${1}"
920
921 local lang
922 for lang in ${path}/*.po; do
923 lang="$(basename "${lang}")"
924 echo "${lang%*.po}"
925 done | sort -u > "${path}/LINGUAS"
926 }
927
928 contributors() {
929 local commits name
930
931 git shortlog --summary --numbered | while read -r commits name; do
932 echo "${name}"
933 done | grep -vE -e "^(alpha197|morlix|root|ummeegge)$" -e "via Development$" -e "@" -e "#$"
934 }
935
936 update_contributors() {
937 echo -n "Updating list of contributors"
938
939 local contributors="$(contributors | paste -sd , - | sed -e "s/,/&\\\\n/g")"
940
941 # Edit contributors into credits.cgi
942 local tmp="$(mktemp)"
943
944 awk "/<!-- CONTRIBUTORS -->/{ p=1; print; printf \"${contributors}\n\"}/<!-- END -->/{ p=0 } !p" \
945 < "${BASEDIR}/html/cgi-bin/credits.cgi" > "${tmp}"
946
947 # Copy back modified content
948 cat "${tmp}" > "${BASEDIR}/html/cgi-bin/credits.cgi"
949 unlink "${tmp}"
950
951 print_status DONE
952 return 0
953 }
954
955 # Default settings
956 CCACHE_CACHE_SIZE="4G"
957 ENABLE_RAMDISK="auto"
958
959 # Load configuration file
960 if [ -f .config ]; then
961 . .config
962 fi
963
964 # TARGET_ARCH is BUILD_ARCH now
965 if [ -n "${TARGET_ARCH}" ]; then
966 BUILD_ARCH="${TARGET_ARCH}"
967 unset TARGET_ARCH
968 fi
969
970 # Get some information about the host system
971 SYSTEM_PROCESSORS="$(system_processors)"
972 SYSTEM_MEMORY="$(system_memory)"
973
974 if [ -n "${BUILD_ARCH}" ]; then
975 configure_build "${BUILD_ARCH}"
976 else
977 configure_build "default"
978 fi
979
980 # Automatically enable/disable ramdisk usage
981 if [ "${ENABLE_RAMDISK}" = "auto" ]; then
982 # Enable only when the host system has 4GB of RAM or more
983 if [ ${SYSTEM_MEMORY} -ge 3900 ]; then
984 ENABLE_RAMDISK="on"
985 fi
986 fi
987
988 buildtoolchain() {
989 local error=false
990 case "${BUILD_ARCH}:${HOST_ARCH}" in
991 # x86_64
992 x86_64:x86_64)
993 # This is working.
994 ;;
995
996 # ARM
997 arvm7hl:armv7hl|armv7hl:armv7l)
998 # These are working.
999 ;;
1000
1001 armv6l:armv6l|armv6l:armv7l|armv6l:aarch64)
1002 # These are working.
1003 ;;
1004 armv6l:*)
1005 error=true
1006 ;;
1007 esac
1008
1009 ${error} && \
1010 exiterror "Cannot build ${BUILD_ARCH} toolchain on $(uname -m). Please use the download if any."
1011
1012 local gcc=$(type -p gcc)
1013 if [ -z "${gcc}" ]; then
1014 exiterror "Could not find GCC. You will need a working build enviroment in order to build the toolchain."
1015 fi
1016
1017 # Check ${TOOLS_DIR} symlink
1018 if [ -h "${TOOLS_DIR}" ]; then
1019 rm -f "${TOOLS_DIR}"
1020 fi
1021
1022 if [ ! -e "${TOOLS_DIR}" ]; then
1023 ln -s "${BASEDIR}/build${TOOLS_DIR}" "${TOOLS_DIR}"
1024 fi
1025
1026 if [ ! -h "${TOOLS_DIR}" ]; then
1027 exiterror "Could not create ${TOOLS_DIR} symbolic link"
1028 fi
1029
1030 LOGFILE="$BASEDIR/log/_build.toolchain.log"
1031 export LOGFILE
1032
1033 lfsmake1 stage1
1034 lfsmake1 binutils PASS=1
1035 lfsmake1 gcc PASS=1
1036 lfsmake1 linux KCFG="-headers"
1037 lfsmake1 glibc
1038 lfsmake1 libxcrypt
1039 lfsmake1 gcc PASS=L
1040 lfsmake1 zlib
1041 lfsmake1 binutils PASS=2
1042 lfsmake1 gcc PASS=2
1043 lfsmake1 zstd
1044 lfsmake1 ccache
1045 lfsmake1 tcl
1046 lfsmake1 expect
1047 lfsmake1 dejagnu
1048 lfsmake1 pkg-config
1049 lfsmake1 ncurses
1050 lfsmake1 bash
1051 lfsmake1 bzip2
1052 lfsmake1 automake
1053 lfsmake1 coreutils
1054 lfsmake1 diffutils
1055 lfsmake1 findutils
1056 lfsmake1 gawk
1057 lfsmake1 gettext
1058 lfsmake1 grep
1059 lfsmake1 gzip
1060 lfsmake1 m4
1061 lfsmake1 make
1062 lfsmake1 patch
1063 lfsmake1 perl
1064 lfsmake1 python3
1065 lfsmake1 sed
1066 lfsmake1 tar
1067 lfsmake1 texinfo
1068 lfsmake1 xz
1069 lfsmake1 bison
1070 lfsmake1 flex
1071 lfsmake1 fake-environ
1072 CUSTOM_PATH="${PATH}" lfsmake1 strip
1073 lfsmake1 cleanup-toolchain
1074 }
1075
1076 buildbase() {
1077 LOGFILE="$BASEDIR/log/_build.base.log"
1078 export LOGFILE
1079 lfsmake2 stage2
1080 lfsmake2 linux KCFG="-headers"
1081 lfsmake2 man-pages
1082 lfsmake2 glibc
1083 lfsmake2 tzdata
1084 lfsmake2 cleanup-toolchain
1085 lfsmake2 zlib
1086 lfsmake2 zstd
1087 lfsmake2 autoconf
1088 lfsmake2 automake
1089 lfsmake2 libtool
1090 lfsmake2 binutils
1091 lfsmake2 gmp
1092 lfsmake2 mpfr
1093 lfsmake2 libmpc
1094 lfsmake2 libxcrypt
1095 lfsmake2 file
1096 lfsmake2 gcc
1097 lfsmake2 sed
1098 lfsmake2 berkeley
1099 lfsmake2 coreutils
1100 lfsmake2 iana-etc
1101 lfsmake2 m4
1102 lfsmake2 bison
1103 lfsmake2 ncurses
1104 lfsmake2 perl
1105 lfsmake2 readline
1106 lfsmake2 bzip2
1107 lfsmake2 xz
1108 lfsmake2 lzip
1109 lfsmake2 pcre
1110 lfsmake2 pcre2
1111 lfsmake2 gettext
1112 lfsmake2 attr
1113 lfsmake2 acl
1114 lfsmake2 bash
1115 lfsmake2 diffutils
1116 lfsmake2 ed
1117 lfsmake2 findutils
1118 lfsmake2 flex
1119 lfsmake2 gawk
1120 lfsmake2 go
1121 lfsmake2 grep
1122 lfsmake2 groff
1123 lfsmake2 gperf
1124 lfsmake2 gzip
1125 lfsmake2 hostname
1126 lfsmake2 whois
1127 lfsmake2 kbd
1128 lfsmake2 less
1129 lfsmake2 pkg-config
1130 lfsmake2 procps
1131 lfsmake2 make
1132 lfsmake2 man
1133 lfsmake2 net-tools
1134 lfsmake2 patch
1135 lfsmake2 psmisc
1136 lfsmake2 shadow
1137 lfsmake2 sysklogd
1138 lfsmake2 sysvinit
1139 lfsmake2 tar
1140 lfsmake2 texinfo
1141 lfsmake2 util-linux
1142 lfsmake2 vim
1143 lfsmake2 e2fsprogs
1144 lfsmake2 jq
1145 }
1146
1147 buildipfire() {
1148 LOGFILE="$BASEDIR/log/_build.ipfire.log"
1149 export LOGFILE
1150 lfsmake2 configroot
1151 lfsmake2 initscripts
1152 lfsmake2 backup
1153 lfsmake2 openssl
1154 lfsmake2 kmod
1155 lfsmake2 udev
1156 lfsmake2 popt
1157 lfsmake2 libedit
1158 lfsmake2 libusb
1159 lfsmake2 libusb-compat
1160 lfsmake2 libpcap
1161 lfsmake2 ppp
1162 lfsmake2 pptp
1163 lfsmake2 unzip
1164 lfsmake2 which
1165 lfsmake2 linux-firmware
1166 lfsmake2 dvb-firmwares
1167 lfsmake2 xr819-firmware
1168 lfsmake2 zd1211-firmware
1169 lfsmake2 rpi-firmware
1170 lfsmake2 intel-microcode
1171 lfsmake2 pcengines-apu-firmware
1172 lfsmake2 bc
1173 lfsmake2 u-boot MKIMAGE=1
1174 lfsmake2 cpio
1175 lfsmake2 mdadm
1176 lfsmake2 dracut
1177 lfsmake2 libaio
1178 lfsmake2 lvm2
1179 lfsmake2 multipath-tools
1180 lfsmake2 freetype
1181 lfsmake2 libmnl
1182 lfsmake2 libnfnetlink
1183 lfsmake2 libnetfilter_queue
1184 lfsmake2 libnetfilter_conntrack
1185 lfsmake2 libnetfilter_cthelper
1186 lfsmake2 libnetfilter_cttimeout
1187 lfsmake2 iptables
1188 lfsmake2 iproute2
1189 lfsmake2 screen
1190 lfsmake2 elfutils
1191
1192 # Kernelbuild ... current we have no platform that need
1193 # multi kernel builds so KCFG is empty
1194 lfsmake2 linux KCFG=""
1195 lfsmake2 rtl8189es KCFG=""
1196 lfsmake2 rtl8812au KCFG=""
1197 lfsmake2 rtl8822bu KCFG=""
1198 lfsmake2 xradio KCFG=""
1199 lfsmake2 xtables-addons KCFG=""
1200 lfsmake2 linux-initrd KCFG=""
1201
1202 lfsmake2 xtables-addons USPACE="1"
1203 lfsmake2 libgpg-error
1204 lfsmake2 libgcrypt
1205 lfsmake2 libassuan
1206 lfsmake2 nettle
1207 lfsmake2 json-c
1208 lfsmake2 libconfig
1209 lfsmake2 libevent
1210 lfsmake2 libevent2
1211 lfsmake2 expat
1212 lfsmake2 apr
1213 lfsmake2 aprutil
1214 lfsmake2 unbound
1215 lfsmake2 gnutls
1216 lfsmake2 libuv
1217 lfsmake2 bind
1218 lfsmake2 dhcp
1219 lfsmake2 dhcpcd
1220 lfsmake2 boost
1221 lfsmake2 linux-atm
1222 lfsmake2 gdbm
1223 lfsmake2 pam
1224 lfsmake2 c-ares
1225 lfsmake2 curl
1226 lfsmake2 tcl
1227 lfsmake2 sqlite
1228 lfsmake2 libffi
1229 lfsmake2 python3
1230 lfsmake2 rust
1231 lfsmake2 rust-dissimilar
1232 lfsmake2 rust-cfg-if
1233 lfsmake2 rust-libc
1234 lfsmake2 rust-getrandom
1235 lfsmake2 rust-typenum
1236 lfsmake2 rust-version-check
1237 lfsmake2 rust-generic-array
1238 lfsmake2 rust-cipher
1239 lfsmake2 rust-hex
1240 lfsmake2 rust-unicode-xid
1241 lfsmake2 rust-proc-macro2
1242 lfsmake2 rust-quote
1243 lfsmake2 rust-syn
1244 lfsmake2 rust-home
1245 lfsmake2 rust-lazy-static
1246 lfsmake2 rust-memchr
1247 lfsmake2 rust-aho-corasick
1248 lfsmake2 rust-regex-syntax
1249 lfsmake2 rust-regex
1250 lfsmake2 rust-ucd-trie
1251 lfsmake2 rust-pest
1252 lfsmake2 rust-semver-parser
1253 lfsmake2 rust-semver
1254 lfsmake2 rust-same-file
1255 lfsmake2 rust-walkdir
1256 lfsmake2 rust-dirs
1257 lfsmake2 rust-toolchain_find
1258 lfsmake2 rust-serde
1259 lfsmake2 rust-itoa
1260 lfsmake2 rust-ryu
1261 lfsmake2 rust-serde_json
1262 lfsmake2 rust-synstructure
1263 lfsmake2 rust-block-buffer
1264 lfsmake2 rust-crypto-common
1265 lfsmake2 rust-digest
1266 lfsmake2 rust-ppv-lite86
1267 lfsmake2 rust-rand_core
1268 lfsmake2 rust-rand_core-0.4.2
1269 lfsmake2 rust-rand_core-0.3.1
1270 lfsmake2 rust-rand_chacha
1271 lfsmake2 rust-rand_hc
1272 lfsmake2 rust-rand
1273 lfsmake2 rust-rdrand
1274 lfsmake2 rust-rand-0.4
1275 lfsmake2 rust-log
1276 lfsmake2 rust-num_cpus
1277 lfsmake2 rust-crossbeam-utils
1278 lfsmake2 rust-autocfg
1279 lfsmake2 rust-memoffset
1280 lfsmake2 rust-scopeguard
1281 lfsmake2 rust-crossbeam-epoch
1282 lfsmake2 rust-crossbeam-deque
1283 lfsmake2 rust-either
1284 lfsmake2 rust-crossbeam-channel
1285 lfsmake2 rust-rayon-core
1286 lfsmake2 rust-rayon
1287 lfsmake2 rust-remove_dir_all
1288 lfsmake2 rust-tempdir
1289 lfsmake2 rust-glob
1290 lfsmake2 rust-once_cell
1291 lfsmake2 rust-termcolor
1292 lfsmake2 rust-toml
1293 lfsmake2 rust-serde_derive
1294 lfsmake2 rust-trybuild
1295 lfsmake2 rust-unindent
1296 lfsmake2 rust-proc-macro-hack
1297 lfsmake2 rust-indoc-impl
1298 lfsmake2 rust-indoc
1299 lfsmake2 rust-instant
1300 lfsmake2 rust-lock_api
1301 lfsmake2 rust-smallvec
1302 lfsmake2 rust-parking_lot_core
1303 lfsmake2 rust-parking_lot
1304 lfsmake2 rust-paste-impl
1305 lfsmake2 rust-paste
1306 lfsmake2 rust-ctor
1307 lfsmake2 rust-ghost
1308 lfsmake2 rust-inventory-impl
1309 lfsmake2 rust-inventory
1310 lfsmake2 rust-pyo3-build-config
1311 lfsmake2 rust-pyo3-macros-backend
1312 lfsmake2 rust-pyo3-macros
1313 lfsmake2 rust-pyo3
1314 lfsmake2 gdb
1315 lfsmake2 grub
1316 lfsmake2 efivar
1317 lfsmake2 efibootmgr
1318 lfsmake2 libtasn1
1319 lfsmake2 p11-kit
1320 lfsmake2 ca-certificates
1321 lfsmake2 fireinfo
1322 lfsmake2 libnet
1323 lfsmake2 libnl
1324 lfsmake2 libnl-3
1325 lfsmake2 libidn
1326 lfsmake2 nasm
1327 lfsmake2 libarchive
1328 lfsmake2 cmake
1329 lfsmake2 ninja
1330 lfsmake2 meson
1331 lfsmake2 libjpeg
1332 lfsmake2 openjpeg
1333 lfsmake2 libexif
1334 lfsmake2 libpng
1335 lfsmake2 libtiff
1336 lfsmake2 libart
1337 lfsmake2 gd
1338 lfsmake2 slang
1339 lfsmake2 newt
1340 lfsmake2 libsmooth
1341 lfsmake2 libcap
1342 lfsmake2 libcap-ng
1343 lfsmake2 pciutils
1344 lfsmake2 usbutils
1345 lfsmake2 libxml2
1346 lfsmake2 libxslt
1347 lfsmake2 BerkeleyDB
1348 lfsmake2 cyrus-sasl
1349 lfsmake2 openldap
1350 lfsmake2 apache2
1351 lfsmake2 web-user-interface
1352 lfsmake2 flag-icons
1353 lfsmake2 jquery
1354 lfsmake2 bootstrap
1355 lfsmake2 arping
1356 lfsmake2 beep
1357 lfsmake2 libssh
1358 lfsmake2 libinih
1359 lfsmake2 cdrkit
1360 lfsmake2 dosfstools
1361 lfsmake2 exfatprogs
1362 lfsmake2 reiserfsprogs
1363 lfsmake2 liburcu
1364 lfsmake2 xfsprogs
1365 lfsmake2 sysfsutils
1366 lfsmake2 fuse
1367 lfsmake2 ntfs-3g
1368 lfsmake2 ethtool
1369 lfsmake2 fcron
1370 lfsmake2 ExtUtils-PkgConfig
1371 lfsmake2 perl-GD
1372 lfsmake2 GD-Graph
1373 lfsmake2 GD-TextUtil
1374 lfsmake2 perl-Device-SerialPort
1375 lfsmake2 perl-Device-Modem
1376 lfsmake2 perl-Apache-Htpasswd
1377 lfsmake2 perl-Parse-Yapp
1378 lfsmake2 perl-Data-UUID
1379 lfsmake2 perl-Try-Tiny
1380 lfsmake2 perl-HTTP-Message
1381 lfsmake2 perl-HTTP-Date
1382 lfsmake2 gnupg
1383 lfsmake2 hdparm
1384 lfsmake2 sdparm
1385 lfsmake2 whatmask
1386 lfsmake2 libtirpc
1387 lfsmake2 conntrack-tools
1388 lfsmake2 iputils
1389 lfsmake2 l7-protocols
1390 lfsmake2 hwdata
1391 lfsmake2 logrotate
1392 lfsmake2 logwatch
1393 lfsmake2 misc-progs
1394 lfsmake2 nano
1395 lfsmake2 URI
1396 lfsmake2 perl-CGI
1397 lfsmake2 perl-Switch
1398 lfsmake2 HTML-Tagset
1399 lfsmake2 HTML-Parser
1400 lfsmake2 HTML-Template
1401 lfsmake2 Compress-Zlib
1402 lfsmake2 Digest
1403 lfsmake2 Digest-SHA1
1404 lfsmake2 Digest-HMAC
1405 lfsmake2 libwww-perl
1406 lfsmake2 perl-LWP-Protocol-https
1407 lfsmake2 perl-Net-HTTP
1408 lfsmake2 Net-DNS
1409 lfsmake2 Net-IPv4Addr
1410 lfsmake2 Net_SSLeay
1411 lfsmake2 IO-Stringy
1412 lfsmake2 IO-Socket-SSL
1413 lfsmake2 Unix-Syslog
1414 lfsmake2 Mail-Tools
1415 lfsmake2 MIME-Tools
1416 lfsmake2 Net-Server
1417 lfsmake2 Canary-Stability
1418 lfsmake2 Convert-TNEF
1419 lfsmake2 Convert-UUlib
1420 lfsmake2 Archive-Tar
1421 lfsmake2 Archive-Zip
1422 lfsmake2 Text-Tabs+Wrap
1423 lfsmake2 XML-Parser
1424 lfsmake2 Crypt-PasswdMD5
1425 lfsmake2 Net-Telnet
1426 lfsmake2 python3-setuptools
1427 lfsmake2 python3-inotify
1428 lfsmake2 python3-docutils
1429 lfsmake2 python3-daemon
1430 lfsmake2 glib
1431 lfsmake2 ntp
1432 lfsmake2 openssh
1433 lfsmake2 fontconfig
1434 lfsmake2 dejavu-fonts-ttf
1435 lfsmake2 ubuntu-font-family
1436 lfsmake2 freefont
1437 lfsmake2 pixman
1438 lfsmake2 cairo
1439 lfsmake2 harfbuzz
1440 lfsmake2 fribidi
1441 lfsmake2 pango
1442 lfsmake2 rrdtool
1443 lfsmake2 setup
1444 lfsmake2 libdnet
1445 lfsmake2 jansson
1446 lfsmake2 yaml
1447 lfsmake2 libhtp
1448 lfsmake2 colm
1449 lfsmake2 ragel
1450 lfsmake2 hyperscan
1451 lfsmake2 suricata
1452 lfsmake2 oinkmaster
1453 lfsmake2 ids-ruleset-sources
1454 lfsmake2 squid
1455 lfsmake2 squidguard
1456 lfsmake2 calamaris
1457 lfsmake2 tcpdump
1458 lfsmake2 traceroute
1459 lfsmake2 vlan
1460 lfsmake2 wireless
1461 lfsmake2 pakfire
1462 lfsmake2 spandsp
1463 lfsmake2 lz4
1464 lfsmake2 lzo
1465 lfsmake2 openvpn
1466 lfsmake2 mpage
1467 lfsmake2 dbus
1468 lfsmake2 intltool
1469 lfsmake2 libdaemon
1470 lfsmake2 avahi
1471 lfsmake2 cups
1472 lfsmake2 lcms2
1473 lfsmake2 ghostscript
1474 lfsmake2 qpdf
1475 lfsmake2 poppler
1476 lfsmake2 poppler-data
1477 lfsmake2 cups-filters
1478 lfsmake2 epson-inkjet-printer-escpr
1479 lfsmake2 foomatic
1480 lfsmake2 hplip
1481 lfsmake2 cifs-utils
1482 lfsmake2 krb5
1483 lfsmake2 rpcsvc-proto
1484 lfsmake2 samba
1485 lfsmake2 netatalk
1486 lfsmake2 sudo
1487 lfsmake2 mc
1488 lfsmake2 wget
1489 lfsmake2 bridge-utils
1490 lfsmake2 smartmontools
1491 lfsmake2 htop
1492 lfsmake2 chkconfig
1493 lfsmake2 postfix
1494 lfsmake2 fetchmail
1495 lfsmake2 clamav
1496 lfsmake2 perl-NetAddr-IP
1497 lfsmake2 dma
1498 lfsmake2 alsa
1499 lfsmake2 mpfire
1500 lfsmake2 guardian
1501 lfsmake2 libid3tag
1502 lfsmake2 libmad
1503 lfsmake2 libogg
1504 lfsmake2 libvorbis
1505 lfsmake2 flac
1506 lfsmake2 lame
1507 lfsmake2 sox
1508 lfsmake2 soxr
1509 lfsmake2 libshout
1510 lfsmake2 xvid
1511 lfsmake2 libmpeg2
1512 lfsmake2 gnump3d
1513 lfsmake2 rsync
1514 lfsmake2 rpcbind
1515 lfsmake2 keyutils
1516 lfsmake2 nfs
1517 lfsmake2 gnu-netcat
1518 lfsmake2 ncat
1519 lfsmake2 nmap
1520 lfsmake2 etherwake
1521 lfsmake2 bwm-ng
1522 lfsmake2 sysstat
1523 lfsmake2 strongswan
1524 lfsmake2 rng-tools
1525 lfsmake2 lsof
1526 lfsmake2 br2684ctl
1527 lfsmake2 pcmciautils
1528 lfsmake2 lm_sensors
1529 lfsmake2 libstatgrab
1530 lfsmake2 liboping
1531 lfsmake2 collectd
1532 lfsmake2 elinks
1533 lfsmake2 igmpproxy
1534 lfsmake2 opus
1535 lfsmake2 python3-pyparsing
1536 lfsmake2 spice-protocol
1537 lfsmake2 spice
1538 lfsmake2 sdl2
1539 lfsmake2 libusbredir
1540 lfsmake2 libseccomp
1541 lfsmake2 qemu
1542 lfsmake2 netpbm
1543 lfsmake2 netsnmpd
1544 lfsmake2 nagios_nrpe
1545 lfsmake2 nagios-plugins
1546 lfsmake2 icinga
1547 lfsmake2 observium-agent
1548 lfsmake2 ebtables
1549 lfsmake2 faad2
1550 lfsmake2 alac
1551 lfsmake2 ffmpeg
1552 lfsmake2 vdr
1553 lfsmake2 vdr_streamdev
1554 lfsmake2 vdr_epgsearch
1555 lfsmake2 vdr_dvbapi
1556 lfsmake2 vdr_eepg
1557 lfsmake2 w_scan
1558 lfsmake2 mpd
1559 lfsmake2 libmpdclient
1560 lfsmake2 mpc
1561 lfsmake2 perl-Net-CIDR-Lite
1562 lfsmake2 perl-Net-SMTP-SSL
1563 lfsmake2 perl-MIME-Base64
1564 lfsmake2 perl-Authen-SASL
1565 lfsmake2 perl-MIME-Lite
1566 lfsmake2 perl-Email-Date-Format
1567 lfsmake2 git
1568 lfsmake2 squidclamav
1569 lfsmake2 vnstat
1570 lfsmake2 iw
1571 lfsmake2 wpa_supplicant
1572 lfsmake2 hostapd
1573 lfsmake2 syslinux
1574 lfsmake2 tftpd
1575 lfsmake2 cpufrequtils
1576 lfsmake2 gutenprint
1577 lfsmake2 apcupsd
1578 lfsmake2 fireperf
1579 lfsmake2 iperf
1580 lfsmake2 iperf3
1581 lfsmake2 7zip
1582 lfsmake2 lynis
1583 lfsmake2 sshfs
1584 lfsmake2 taglib
1585 lfsmake2 sslh
1586 lfsmake2 perl-gettext
1587 lfsmake2 perl-Sort-Naturally
1588 lfsmake2 vdradmin
1589 lfsmake2 perl-DBI
1590 lfsmake2 perl-DBD-SQLite
1591 lfsmake2 perl-File-ReadBackwards
1592 lfsmake2 openvmtools
1593 lfsmake2 joe
1594 lfsmake2 monit
1595 lfsmake2 nut
1596 lfsmake2 watchdog
1597 lfsmake2 libpri
1598 lfsmake2 usb_modeswitch
1599 lfsmake2 usb_modeswitch_data
1600 lfsmake2 zerofree
1601 lfsmake2 minicom
1602 lfsmake2 ddrescue
1603 lfsmake2 powertop
1604 lfsmake2 parted
1605 lfsmake2 swig
1606 lfsmake2 dtc
1607 lfsmake2 u-boot
1608 lfsmake2 u-boot-friendlyarm
1609 lfsmake2 wireless-regdb
1610 lfsmake2 libsolv
1611 lfsmake2 ddns
1612 lfsmake2 python3-toml
1613 lfsmake2 python3-pyproject2setuppy
1614 lfsmake2 python3-tomli
1615 lfsmake2 python3-setuptools-scm
1616 lfsmake2 python3-packaging
1617 lfsmake2 python3-six
1618 lfsmake2 python3-dateutil
1619 lfsmake2 python3-jmespath
1620 lfsmake2 python3-colorama
1621 lfsmake2 python3-yaml
1622 lfsmake2 python3-s3transfer
1623 lfsmake2 python3-rsa
1624 lfsmake2 python3-pyasn1
1625 lfsmake2 python3-urllib3
1626 lfsmake2 python3-botocore
1627 lfsmake2 aws-cli
1628 lfsmake2 transmission
1629 lfsmake2 mtr
1630 lfsmake2 minidlna
1631 lfsmake2 acpid
1632 lfsmake2 fping
1633 lfsmake2 telnet
1634 lfsmake2 xinetd
1635 lfsmake2 stress
1636 lfsmake2 sarg
1637 lfsmake2 nginx
1638 lfsmake2 sysbench
1639 lfsmake2 strace
1640 lfsmake2 ltrace
1641 lfsmake2 ipfire-netboot
1642 lfsmake2 lcdproc
1643 lfsmake2 keepalived
1644 lfsmake2 ipvsadm
1645 lfsmake2 perl-Carp-Clan
1646 lfsmake2 perl-Date-Calc
1647 lfsmake2 perl-Date-Manip
1648 lfsmake2 perl-File-Tail
1649 lfsmake2 perl-TimeDate
1650 lfsmake2 swatch
1651 lfsmake2 tor
1652 lfsmake2 wavemon
1653 lfsmake2 iptraf-ng
1654 lfsmake2 iotop
1655 lfsmake2 stunnel
1656 lfsmake2 bacula
1657 lfsmake2 perl-Font-TTF
1658 lfsmake2 perl-IO-String
1659 lfsmake2 perl-PDF-API2
1660 lfsmake2 squid-accounting
1661 lfsmake2 pigz
1662 lfsmake2 tmux
1663 lfsmake2 perl-Text-CSV_XS
1664 lfsmake2 lua
1665 lfsmake2 haproxy
1666 lfsmake2 ipset
1667 lfsmake2 dnsdist
1668 lfsmake2 bird
1669 lfsmake2 libyang
1670 lfsmake2 frr
1671 lfsmake2 dmidecode
1672 lfsmake2 mcelog
1673 lfsmake2 libpciaccess
1674 lfsmake2 libyajl
1675 lfsmake2 libvirt
1676 lfsmake2 libtalloc
1677 lfsmake2 freeradius
1678 lfsmake2 perl-common-sense
1679 lfsmake2 perl-inotify2
1680 lfsmake2 perl-Net-IP
1681 lfsmake2 wio
1682 lfsmake2 iftop
1683 lfsmake2 mdns-repeater
1684 lfsmake2 i2c-tools
1685 lfsmake2 nss-myhostname
1686 lfsmake2 dehydrated
1687 lfsmake2 shairport-sync
1688 lfsmake2 borgbackup
1689 lfsmake2 lmdb
1690 lfsmake2 knot
1691 lfsmake2 spectre-meltdown-checker
1692 lfsmake2 zabbix_agentd
1693 lfsmake2 flashrom
1694 lfsmake2 firmware-update
1695 lfsmake2 tshark
1696 lfsmake2 speedtest-cli
1697 lfsmake2 rfkill
1698 lfsmake2 amazon-ssm-agent
1699 lfsmake2 libloc
1700 lfsmake2 ncdu
1701 lfsmake2 lshw
1702 lfsmake2 socat
1703 lfsmake2 libcdada
1704 lfsmake2 pmacct
1705 lfsmake2 squid-asnbl
1706 lfsmake2 qemu-ga
1707 }
1708
1709 buildinstaller() {
1710 # Run installer scripts one by one
1711 LOGFILE="$BASEDIR/log/_build.installer.log"
1712 export LOGFILE
1713 lfsmake2 memtest
1714 lfsmake2 installer
1715 # use toolchain bash for chroot to strip
1716 CUSTOM_PATH="${TOOLS_DIR}/bin" lfsmake2 strip
1717 }
1718
1719 buildpackages() {
1720 LOGFILE="$BASEDIR/log/_build.packages.log"
1721 export LOGFILE
1722 echo "... see detailed log in _build.*.log files" >> $LOGFILE
1723
1724
1725 # Generating list of packages used
1726 print_line "Generating packages list from logs"
1727 rm -f $BASEDIR/doc/packages-list
1728 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
1729 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
1730 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
1731 fi
1732 done
1733 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
1734 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
1735 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
1736 rm -f $BASEDIR/doc/packages-list
1737 # packages-list.txt is ready to be displayed for wiki page
1738 print_status DONE
1739
1740 # Update changelog
1741 cd $BASEDIR
1742 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
1743 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
1744 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
1745
1746 # Create images for install
1747 lfsmake2 cdrom
1748
1749 # Check if there is a loop device for building in virtual environments
1750 modprobe loop 2>/dev/null
1751 if [ $BUILD_IMAGES == 1 ] && ([ -e /dev/loop/0 ] || [ -e /dev/loop0 ] || [ -e "/dev/loop-control" ]); then
1752 lfsmake2 flash-images
1753 fi
1754
1755 mv $LFS/install/images/{*.iso,*.img.xz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
1756
1757 ipfirepackages
1758
1759 cd $BASEDIR
1760
1761 # remove not useable iso on armv6l (needed to build flash images)
1762 [ "${BUILD_ARCH}" = "armv6l" ] && rm -rf *.iso
1763
1764 for i in $(ls *.bz2 *.img.xz *.iso 2>/dev/null); do
1765 md5sum $i > $i.md5
1766 done
1767 cd $PWD
1768
1769 # Cleanup
1770 stdumount
1771 rm -rf $BASEDIR/build/tmp/*
1772
1773 cd $PWD
1774 }
1775
1776 ipfirepackages() {
1777 lfsmake2 core-updates
1778
1779 local i
1780 for i in $(find $BASEDIR/config/rootfiles/packages{/${BUILD_ARCH},} -maxdepth 1 -type f); do
1781 i=$(basename ${i})
1782 if [ -e $BASEDIR/lfs/$i ]; then
1783 ipfiredist $i
1784 else
1785 echo -n $i
1786 print_status SKIP
1787 fi
1788 done
1789 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
1790 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
1791 rm -rf $BASEDIR/build/install/packages/*
1792 }
1793
1794 while [ $# -gt 0 ]; do
1795 case "${1}" in
1796 --target=*)
1797 configure_build "${1#--target=}"
1798 ;;
1799 -*)
1800 exiterror "Unknown configuration option: ${1}"
1801 ;;
1802 *)
1803 # Found a command, so exit options parsing.
1804 break
1805 ;;
1806 esac
1807 shift
1808 done
1809
1810 # See what we're supposed to do
1811 case "$1" in
1812 build)
1813 START_TIME=$(now)
1814
1815 # Clear screen
1816 ${INTERACTIVE} && clear
1817
1818 PACKAGE="$BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.zst"
1819 #only restore on a clean disk
1820 if [ ! -e "${BASEDIR}/build${TOOLS_DIR}/.toolchain-successful" ]; then
1821 if [ ! -n "$PACKAGE" ]; then
1822 print_build_stage "Full toolchain compilation"
1823 prepareenv
1824 buildtoolchain
1825 else
1826 PACKAGENAME=${PACKAGE%.tar.zst}
1827 print_build_stage "Packaged toolchain compilation"
1828 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
1829 zstd -d < "${PACKAGE}" | tar x
1830 prepareenv
1831 else
1832 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
1833 fi
1834 fi
1835 else
1836 prepareenv
1837 fi
1838
1839 print_build_stage "Building LFS"
1840 buildbase
1841
1842 print_build_stage "Building IPFire"
1843 buildipfire
1844
1845 print_build_stage "Building installer"
1846 buildinstaller
1847
1848 print_build_stage "Building packages"
1849 buildpackages
1850
1851 print_build_stage "Checking Logfiles for new Files"
1852
1853 cd $BASEDIR
1854 tools/checknewlog.pl
1855 tools/checkrootfiles
1856 cd $PWD
1857
1858 print_build_summary $(( $(now) - ${START_TIME} ))
1859 ;;
1860 shell)
1861 # enter a shell inside LFS chroot
1862 # may be used to changed kernel settings
1863 prepareenv
1864 entershell
1865 ;;
1866 clean)
1867 print_line "Cleaning build directory..."
1868
1869 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
1870 $LOSETUP -d $i 2>/dev/null
1871 done
1872 #for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
1873 # umount $i
1874 #done
1875 stdumount
1876 for i in `seq 0 7`; do
1877 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
1878 umount /dev/loop${i} 2>/dev/null;
1879 losetup -d /dev/loop${i} 2>/dev/null;
1880 fi;
1881 done
1882 rm -rf $BASEDIR/build
1883 rm -rf $BASEDIR/cdrom
1884 rm -rf $BASEDIR/packages
1885 rm -rf $BASEDIR/log
1886 if [ -h "${TOOLS_DIR}" ]; then
1887 rm -f "${TOOLS_DIR}"
1888 fi
1889 rm -f $BASEDIR/ipfire-*
1890 print_status DONE
1891 ;;
1892 docker)
1893 # Build the docker image if it does not exist, yet
1894 if ! docker images -a | grep -q ^ipfire-builder; then
1895 if docker build -t ipfire-builder ${BASEDIR}/tools/docker; then
1896 print_status DONE
1897 else
1898 print_status FAIL
1899 exit 1
1900 fi
1901 fi
1902
1903 # Run the container and enter a shell
1904 docker run -it --privileged -v "${BASEDIR}:/build" -w "/build" ipfire-builder bash -l
1905 ;;
1906 downloadsrc)
1907 if [ ! -d $BASEDIR/cache ]; then
1908 mkdir $BASEDIR/cache
1909 fi
1910 mkdir -p $BASEDIR/log
1911 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
1912 FINISHED=0
1913 cd $BASEDIR/lfs
1914 for c in `seq $MAX_RETRIES`; do
1915 if (( FINISHED==1 )); then
1916 break
1917 fi
1918 FINISHED=1
1919 cd $BASEDIR/lfs
1920 for i in *; do
1921 if [ -f "$i" -a "$i" != "Config" ]; then
1922 lfsmakecommoncheck ${i} || continue
1923
1924 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
1925 MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
1926 if [ $? -ne 0 ]; then
1927 print_status FAIL
1928 FINISHED=0
1929 else
1930 if [ $c -eq 1 ]; then
1931 print_status DONE
1932 fi
1933 fi
1934 fi
1935 done
1936 done
1937 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
1938 ERROR=0
1939 for i in *; do
1940 if [ -f "$i" -a "$i" != "Config" ]; then
1941 lfsmakecommoncheck ${i} > /dev/null || continue
1942 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
1943 MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
1944 if [ $? -ne 0 ]; then
1945 echo -ne "MD5 difference in lfs/$i"
1946 print_status FAIL
1947 ERROR=1
1948 fi
1949 fi
1950 done
1951 if [ $ERROR -eq 0 ]; then
1952 echo -ne "${BOLD}all files md5sum match${NORMAL}"
1953 print_status DONE
1954 else
1955 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
1956 print_status FAIL
1957 fi
1958 cd - >/dev/null 2>&1
1959 ;;
1960 toolchain)
1961 # Clear screen
1962 ${INTERACTIVE} && clear
1963
1964 prepareenv
1965 print_build_stage "Toolchain compilation (${BUILD_ARCH})"
1966 buildtoolchain
1967 echo "`date -u '+%b %e %T'`: Create toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
1968 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
1969 cd $BASEDIR && tar -cf- --exclude='log/_build.*.log' build/${TOOLS_DIR} build/bin/sh log \
1970 | zstd ${ZSTD_OPT} > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.zst
1971 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.zst \
1972 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.md5
1973 stdumount
1974 ;;
1975 gettoolchain)
1976 # arbitrary name to be updated in case of new toolchain package upload
1977 PACKAGE=$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}
1978 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.zst ]; then
1979 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
1980 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
1981 echo "`date -u '+%b %e %T'`: Load toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
1982 cd $BASEDIR/cache/toolchains
1983 wget -U "IPFireSourceGrabber/2.x" $URL_TOOLCHAIN/$PACKAGE.tar.zst $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
1984 if [ $? -ne 0 ]; then
1985 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for ${BUILD_ARCH} machine" | tee -a $LOGFILE
1986 else
1987 if [ "`md5sum $PACKAGE.tar.zst | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
1988 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
1989 else
1990 exiterror "$PACKAGE.md5 did not match, check downloaded package"
1991 fi
1992 fi
1993 else
1994 echo "Toolchain is already downloaded. Exiting..."
1995 fi
1996 ;;
1997 uploadsrc)
1998 if [ -z $IPFIRE_USER ]; then
1999 echo -n "You have to setup IPFIRE_USER first. See .config for details."
2000 print_status FAIL
2001 exit 1
2002 fi
2003
2004 URL_SOURCE="$(awk '/^URL_SOURCE/ { print $3 }' lfs/Config)"
2005
2006 rsync \
2007 --recursive \
2008 --update \
2009 --ignore-existing \
2010 --progress \
2011 --human-readable \
2012 --exclude="toolchains/" \
2013 "${BASEDIR}/cache/" \
2014 "${IPFIRE_USER}@${URL_SOURCE}"
2015
2016 exit 0
2017 ;;
2018 lang)
2019 echo -ne "Checking the translations for missing or obsolete strings..."
2020 chmod 755 $BASEDIR/tools/{check_strings.pl,sort_strings.pl,check_langs.sh}
2021 $BASEDIR/tools/sort_strings.pl en
2022 $BASEDIR/tools/sort_strings.pl de
2023 $BASEDIR/tools/sort_strings.pl fr
2024 $BASEDIR/tools/sort_strings.pl es
2025 $BASEDIR/tools/sort_strings.pl pl
2026 $BASEDIR/tools/sort_strings.pl ru
2027 $BASEDIR/tools/sort_strings.pl nl
2028 $BASEDIR/tools/sort_strings.pl tr
2029 $BASEDIR/tools/sort_strings.pl it
2030 $BASEDIR/tools/check_strings.pl en > $BASEDIR/doc/language_issues.en
2031 $BASEDIR/tools/check_strings.pl de > $BASEDIR/doc/language_issues.de
2032 $BASEDIR/tools/check_strings.pl fr > $BASEDIR/doc/language_issues.fr
2033 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.es
2034 $BASEDIR/tools/check_strings.pl pl > $BASEDIR/doc/language_issues.pl
2035 $BASEDIR/tools/check_strings.pl ru > $BASEDIR/doc/language_issues.ru
2036 $BASEDIR/tools/check_strings.pl nl > $BASEDIR/doc/language_issues.nl
2037 $BASEDIR/tools/check_strings.pl tr > $BASEDIR/doc/language_issues.tr
2038 $BASEDIR/tools/check_strings.pl it > $BASEDIR/doc/language_issues.it
2039 $BASEDIR/tools/check_langs.sh > $BASEDIR/doc/language_missings
2040 print_status DONE
2041
2042 echo -ne "Updating language lists..."
2043 update_language_list ${BASEDIR}/src/installer/po
2044 update_language_list ${BASEDIR}/src/setup/po
2045 print_status DONE
2046 ;;
2047 update-contributors)
2048 update_contributors
2049 ;;
2050 find-dependencies)
2051 shift
2052 exec "${BASEDIR}/tools/find-dependencies" "${BASEDIR}/build" "$@"
2053 ;;
2054 check-manualpages)
2055 echo "Checking the manual pages for broken links..."
2056
2057 chmod 755 $BASEDIR/tools/check_manualpages.pl
2058 if $BASEDIR/tools/check_manualpages.pl; then
2059 print_status DONE
2060 else
2061 print_status FAIL
2062 fi
2063 ;;
2064 *)
2065 echo "Usage: $0 [OPTIONS] {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain|update-contributors|find-dependencies|check-manualpages}"
2066 cat doc/make.sh-usage
2067 ;;
2068 esac
2069